import uuid
from abc import abstractmethod
from dataclasses import dataclass
from datetime import datetime
from typing import Any, Callable

import pytest
from aaambos.core.communication.topic import Topic
from aaambos.core.execution.standalone import StandaloneModuleTestExtension, EndTestException, StandaloneTest, \
    define_test_standalone_feature

from simple_flexdiam.modules.core.definitions import SPEECH_GENERATION_CONTROL, SpeechGenerationControl, AsrResults, \
    AsrResultState, ASR_RESULTS, NluResults, NLU_RESULTS, SpeechGenerationStatus, Status, SPEECH_GENERATION_STATUS
from simple_flexdiam.modules.simple_flexdiam_module import SimpleFlexdiam
from simple_flexdiam.modules.std.tiers.basic import UserWordsTier
from simple_flexdiam.tests import simple_module_config


@dataclass
class SingleSpeechTurn:
    """See example usage below for default issues."""
    utterance: str
    intention: str
    expected_speech_output: str | list[str] | set[str]
    """str: single utterance, list: several utterances in this order, set: one of the utterances in this set."""
    number_expected_utterances: int = 1
    other_nlu: dict = None
    validation_callback: Callable = None


@dataclass
class FlexdiamInputByData:
    """If you have other Topics and Msgs that should be added and the data can be defined before the start of flexdiam (here in the script) then you can use this dataclass. The validation callbacks can be used to do assertions."""
    leaf_topic: str
    msg: Any
    validation_callback_direct: Callable = None
    validation_callback_next_step: Callable = None


@dataclass
class FlexdiamInputByCallback:
    """If you have other Topics and Msgs that should be added and some data is not available before the start of flexdiam (based on data generated by flexdiam on runtime) then you can use this dataclass. The validation callbacks can be used to do assertions."""
    callback_args: dict
    callback_func: Any
    validation_callback_direct: Callable = None
    validation_callback_next_step: Callable = None


class IssueDialogTestBase(StandaloneModuleTestExtension):
    """Test setup and issue creation from shadow via nlu_entry_point. And check SpeechGeneration."""
    name = "IssueDialogTestBase"
    module: SimpleFlexdiam

    @abstractmethod
    def dialog(self) -> list[SingleSpeechTurn | FlexdiamInputByData | FlexdiamInputByCallback]:
        return []
    
    async def after_module_initialize(self, module):
        self.register_notification_for_send(self.receive_speech_generation, topic_name=SPEECH_GENERATION_CONTROL)
        self.t_start = datetime.now()
        self.step_counter = 0
        self.current_idx = 0
        self.status = None
        self.instruction_phase = 0
        self.speech_buffer = []
        self.jump_other_data = True
        self.dialog_steps = self.dialog()
        

    async def receive_speech_generation(self, topic: Topic, msg: Any):
        assert isinstance(msg, SpeechGenerationControl)
        self.speech_buffer.append(msg.text)
        
        generation_status = SpeechGenerationStatus(id=msg.id, status=Status.running)
        await self.send_to_module(SPEECH_GENERATION_STATUS, generation_status)
        self.status = generation_status
    
    async def step(self):
        self.step_counter += 1
        if self.current_idx >= len(self.dialog_steps):
            raise EndTestException(f"Finished Dialog with {len(self.dialog_steps)} dialog instructions")
        
        current_dialog_instruction = self.dialog_steps[self.current_idx]
        if isinstance(current_dialog_instruction, SingleSpeechTurn):
            if self.instruction_phase == 0:
                utterance_id = uuid.uuid4().hex
                asr_result = AsrResults(state=AsrResultState.FINAL, source="test_extension",
                                        hypotheses=[current_dialog_instruction.utterance], confidences=[0.8], best=current_dialog_instruction.utterance,
                                        best_confidence=0.8, utterance_id=utterance_id)
                await self.send_to_module(ASR_RESULTS, asr_result)
                nlu_kwargs = {"entities": [], "tokens": [], "noun_phrases": []}
                nlu_kwargs.update(current_dialog_instruction.other_nlu or {})
                nlu_result = NluResults(state=AsrResultState.FINAL, intention=current_dialog_instruction.intention, utterance=current_dialog_instruction.utterance, utterance_id=utterance_id, **nlu_kwargs)
                await self.send_to_module(NLU_RESULTS, nlu_result)
                self.instruction_phase += 1
            elif self.instruction_phase < current_dialog_instruction.number_expected_utterances:
                generation_status = SpeechGenerationStatus(id=self.status.id, status=Status.finished)
                await self.send_to_module(SPEECH_GENERATION_STATUS, generation_status)
                self.instruction_phase += 1
            elif self.instruction_phase == current_dialog_instruction.number_expected_utterances:
                if current_dialog_instruction.expected_speech_output:
                    print(type(current_dialog_instruction.expected_speech_output))
                    if isinstance(current_dialog_instruction.expected_speech_output, set):
                        print(
                            f"Expected speech output: {current_dialog_instruction.expected_speech_output} in {self.speech_buffer}")
                        assert len(self.speech_buffer) == 1 and self.speech_buffer[-1] in current_dialog_instruction.expected_speech_output
                        print("---")
                    elif isinstance(current_dialog_instruction.expected_speech_output, list):
                        assert self.speech_buffer == current_dialog_instruction.expected_speech_output
                    else:
                        assert current_dialog_instruction.expected_speech_output in self.speech_buffer
                    print(f"Matched speech output: {current_dialog_instruction.expected_speech_output} in {self.speech_buffer}")
                    generation_status = SpeechGenerationStatus(id=self.status.id, status=Status.finished)
                    await self.send_to_module(SPEECH_GENERATION_STATUS, generation_status)
                else:
                    print("Did not list expected speech output. Skipping check.")
                    print("Agent speech\n", self.speech_buffer, "\n---")
                self.instruction_phase += 1
            elif self.instruction_phase > current_dialog_instruction.number_expected_utterances:
                if current_dialog_instruction.validation_callback:
                    current_dialog_instruction.validation_callback(current_dialog_instruction)
                self.speech_buffer = []
                self.instruction_phase = 0
                self.current_idx += 1
        elif isinstance(current_dialog_instruction, FlexdiamInputByData):
            if self.instruction_phase == 0:
                await self.send_to_module(current_dialog_instruction.leaf_topic, current_dialog_instruction.msg)
                self.instruction_phase += 1
                if current_dialog_instruction.validation_callback_direct:
                    current_dialog_instruction.validation_callback_direct(current_dialog_instruction)
            elif self.instruction_phase == 1:
                if current_dialog_instruction.validation_callback_next_step:
                    current_dialog_instruction.validation_callback_next_step(current_dialog_instruction)
                self.instruction_phase = 0
                self.speech_buffer = []
                self.current_idx += 1
        elif isinstance(current_dialog_instruction, FlexdiamInputByCallback):
            if self.instruction_phase == 0:
                topic, msg = current_dialog_instruction.callback_func(**current_dialog_instruction.callback_args)
                await self.send_to_module(topic, msg)
                self.instruction_phase += 1
                if current_dialog_instruction.validation_callback_direct:
                    current_dialog_instruction.validation_callback_direct(current_dialog_instruction)
            elif self.instruction_phase == 1:
                if current_dialog_instruction.validation_callback_next_step:
                    current_dialog_instruction.validation_callback_next_step(current_dialog_instruction)
                self.instruction_phase = 0
                self.speech_buffer = []
                self.current_idx += 1
        elif self.jump_other_data:
            self.current_idx += 1


class TestExampleIssueDialog(IssueDialogTestBase):
    name = "TestExampleIssueDialog"
    
    def dialog(self) -> list[SingleSpeechTurn | FlexdiamInputByData | FlexdiamInputByCallback]:
        # the intention should be the relevant part
        # set: on of these, list: in this order (with number_expected_utterances), if you cannot compare via == then let it empty ("" or [])
        return [
            SingleSpeechTurn(utterance="Hey!", intention="greet", expected_speech_output={"Hallo!","Hey!","Guten Tag!", "Huhu!"}),
            SingleSpeechTurn(utterance="Wie geht es dir?", intention="howareyou", expected_speech_output=["Wenn ich dich sehe, geht es mir eigentlich immer gut! Und wie geht es dir?"]),
            SingleSpeechTurn(utterance="Gut", intention="feelingwell", expected_speech_output=["Oh, das freut mich!"]),
            SingleSpeechTurn(utterance="Wie geht es dir?", intention="howareyou", expected_speech_output=["Wenn ich dich sehe, geht es mir eigentlich immer gut! Und wie geht es dir?"]),
            SingleSpeechTurn(utterance="Schlecht", intention="feelingnotsowell", number_expected_utterances=2, expected_speech_output=["Das klingt aber nicht so gut.", "Willst du darueber reden?"]),
            SingleSpeechTurn(utterance="EinsZweiDreiVier", intention="repeat_me", expected_speech_output=["EinsZweiDreiVier"]),
        ]
        # You can also use FlexdiamInputByData and FlexdiamInputByCallback to insert other msgs and trigger entry points (here only asr and nlu, which checks SpeechGenerationControl)
    

@pytest.mark.timeout(2)
def test_example_issue_dialog():
    standalone_flexdiam = StandaloneTest(
        module_config=simple_module_config,
        run_config_plus={},
        module_name="standalone_flexdiam"
    )
    standalone_flexdiam.setup(define_test_standalone_feature(TestExampleIssueDialog))
    standalone_flexdiam.run()